from pyloadl import *
from time import gmtime, strftime
from sys import exit

"""

   Displays information on the LoadLeveler multiclusters

"""

# Query MultiClusters 

query = ll_query(MCLUSTERS)
if not PyCObjValid(query):
   print "ll_query(): returns NULL\n"
   exit(-1)

retval = ll_set_request(query, QUERY_ALL, "", ALL_DATA)
if retval != 0:
   print "ll_set_request(): error %d\n" % retval
   exit(-1)

job, num, err = ll_get_objs(query, LL_SCHEDD, "")
if err != 0:
   print "ll_get_objs(): error %d" % err
   exit(-1)

while PyCObjValid(job):

  print ""
  cluster_name = ll_get_data(job,  LL_MClusterName)
  print "%s: type = cluster" % cluster_name
  cluster_local = ll_get_data(job,  LL_MClusterLocal)
  print "\tLocal = %s" % bool(cluster_local)
  cluster_ischeddport = ll_get_data(job, LL_MClusterInboundScheddPort)
  print "\tinbound_schedd_port = %d" % cluster_ischeddport
  cluster_inbhosts = ll_get_data(job, LL_MClusterInboundHosts)
  print "\tinbound_hosts = %s" % cluster_inbhosts
  cluster_outboundhosts = ll_get_data(job, LL_MClusterOutboundHosts)
  print "\toutbound_hosts = %s" % cluster_outboundhosts
  cluster_inclusers = ll_get_data(job, LL_MClusterIncludeUsers)
  print "\tinclude_users = %s" % cluster_inclusers
  cluster_exclusers = ll_get_data(job, LL_MClusterExcludeUsers)
  print "\texclude_users = %s" % cluster_exclusers
  cluster_inclgrps  = ll_get_data(job, LL_MClusterIncludeGroups)
  print "\tinclude_grps = %s" % cluster_inclgrps
  cluster_exclgrps = ll_get_data(job, LL_MClusterExcludeGroups)
  print "\texclude_grps = %s" % cluster_exclgrps
  cluster_inclasses = ll_get_data(job, LL_MClusterIncludeClasses)
  print "\texclude_grps = %s" % cluster_inclasses
  cluster_exclasses = ll_get_data(job, LL_MClusterExcludeClasses)
  print "\texclude_classes = %s" % cluster_exclasses
  print ""

  job = ll_next_obj(query)

